/* $Id: bns_user.h,v 1.4 2005/04/08 14:30:43 sds Exp $ */

/*
 * $Log: bns_user.h,v $
 * Revision 1.4  2005/04/08 14:30:43  sds
 * location of driver has changed. Updated #includes
 *
 * Revision 1.3  2005/04/08 13:34:48  sds
 * Added GNU license.
 *
 * Revision 1.2  2005/04/07 15:34:32  sds
 * edited #include to point to correct location of slm.h driver
 *
 * Revision 1.1  2005/04/07 15:22:55  sds
 * Initial revision
 *
 */

/*
bns_user.h
By Steve D. Sharples.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

The author's email address is steve.sharples@nottingham.ac.uk
*/

/* This is bns_user.h by Steve D Sharples (sds)
 *
 * It is a userspace library to provide useful functions for controlling the
 * BNS 512x512 SLM. It his hacked from the (now deprecated) "bns_main"
 * library, which did the same thing plus other "laser ultrasound-specific"
 * functions, such as producing images of arcs. Those functions
 * are now in the "bns_local" library, which is now part of the /source/hardware/
 * tree.
 *
 * Note that as the code currently stands, only one card is supported.
 */


#ifndef __BNS_SLM__
#define __BNS_SLM__

#ifdef	USING_2_4_KERNEL
#include "../driver_2.4/slm.h"
#else
#include "../driver_2.6/slm.h"
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <stdio.h>

#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <string.h>
using namespace std;

#ifndef BOOL
#define BOOL    int
#define TRUE    1
#define FALSE   0
#endif

#define BNS_SLM "/dev/slm"
#define BNS_NFRAMES 1024
#define BNS_SIZE BNS_ROW_SIZE*BNS_N_ROWS	/* row size and no of rows defined in slm.h */

/* Raising/lowering DPEN seems more likely to make the system crash, so
 * this represents a really long pause (100ms) you can add either side of
 * changing its status with BNS_DISABLE_WRITE or BNS_ENABLE_WRITE */
#define	BNS_DPEN_PARANOID_PAUSE	100000
/* If you want to enable/disable writes as you go (not recommended)
 * uncomment the following line: */
//#define	BNS_ALLOW_USER_DPEN_CONTROL
					
#define	BNS_NOT_CONNECTED	-1
#define	BNS_OK			0
#define BNS_CANT_OPEN_DEVICE	2
#define BNS_CANT_OPEN_IMAGE_FILE 21
#define BNS_CANT_SAVE_IMAGE_FILE 22
#define	BNS_IMAGE_WRITE_ERROR	23

int	bns_open(void);
void	bns_disable_writes(void);
int	bns_power_on(void);
int	bns_power_off(void);
int	bns_set_period(float time_period);
int	bns_set_laser_a(unsigned int t_period, unsigned int amplitude);
int	bns_set_laser_b(unsigned int t_period, unsigned int amplitude);
int	bns_load_image_file(char *filename, unsigned char *image, BOOL diag);
int	bns_save_image_file(char *filename, unsigned char *image, BOOL diag);
int	bns_upload_frame(unsigned char *image, int frame, BOOL display_frame, BOOL diag);
int	bns_display_frame(int frame, BOOL diag);
int	bns_load_and_upload_frame(char *filename, int frame, BOOL display_frame, BOOL diag);

#endif

