/*
bns_change_frame.c
By Steve D. Sharples.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

The author's email address is steve.sharples@nottingham.ac.uk
*/

#include "../../library/bns_user.h"

/*BOOL is #defined in bns_user.h (as are TRUE and FALSE) */
BOOL	sc(char *, char *);


int	main(int argc,char ** argv){
float	period;
int	index		= 1;
BOOL	set_period	= FALSE;
int	frame		= 0;
BOOL	got_frame	= FALSE;
BOOL	verbose_mode	= FALSE;

int n=0,err;

	if((argc==1)||(sc(argv[1],"-?"))){
		printf("Need some arguments!\n\n");
		printf("-fr  -frame       : frame to upload image to (0-1023) (REQUIRED)\n");
		printf("-t   -time_period : time period (not set by default)\n");
		printf("-v   -verbose     : confirm what's been done (not default)\n");
		exit(3);
		}

	while(index<argc){
		if(sc(argv[index],"-v")||sc(argv[index],"-verbose")){
			verbose_mode=TRUE;
			}
		if(sc(argv[index],"-t")||sc(argv[index],"-time_period")){
			sscanf(argv[++index],"%f",&period);
			set_period=TRUE;
			}
		if(sc(argv[index],"-fr")||sc(argv[index],"-frame")){
			sscanf(argv[++index],"%d",&frame);
			got_frame=TRUE;
			}
		index++;
		}

	if(got_frame==FALSE){
		printf("PROBLEM: You haven't specified a frame to display.\n That's kinda the whole point of this program. Use (eg) -fr 10\n");
		exit(1);
		}

	if(frame<0 || frame>(BNS_NFRAMES-1)){
		printf("ERROR! Frame should be between 0 and %d! Quitting...\n",(BNS_NFRAMES-1));
		exit(4);
		}

	if(bns_open()!=BNS_OK) exit(2);

	if(set_period==TRUE){
		if((int)(period/164.4e-6)<6 || period>10){
			printf("ERROR! Time period should be >=0.001 and <=10! Quitting...\n");
			exit(4);
			} 
		if(verbose_mode==TRUE){
			printf("Time period set to: %fs\n",period);
			}
		bns_set_period(period);
		}

	bns_display_frame(frame,verbose_mode); /* Might as well make use of the bns_user diagnostics */
	}	

BOOL sc(char *con,char *var){
	if(strcmp(con,var)==0){
		return TRUE;
		}
	return FALSE;
        }
