/*
bns_power.c
By Steve D. Sharples.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

The author's email address is steve.sharples@nottingham.ac.uk
*/

#include "../../library/bns_user.h"

void	print_instructions(void);
BOOL	sc(char *,char *);

int	main(int argc,char ** argv){
	if(argc!=2){
		print_instructions();
		exit(3);
		}

	if(sc(argv[1],"on")||sc(argv[1],"1")){
		printf("Setting SLM power ON\n");
		if(bns_open()!=BNS_OK) exit(2);
		bns_power_on();
		}

	else if(sc(argv[1],"off")||sc(argv[1],"0")){
		printf("Setting SLM power OFF\n");
		if(bns_open()!=BNS_OK) exit(2);
		bns_power_off();
		}

	else{
		print_instructions();
		exit(4);
		}
	printf("Done.\n");
	return 0;
	}

void	print_instructions(void){
	printf("I need to know whether you want to turn on, or\n");
	printf("turn off, the BNS SLM:\n");
	printf("bns_power on\t| bns_power 1\t: turn on power\n");
	printf("bns_power off\t| bns_power 0\t: turn off power\n");
	}

BOOL	sc(char *con,char *var){
	if(strcmp(con,var)==0) return TRUE;
	return FALSE;
	}
