%MAP2BNS(MAP,FILENAME)
% 
%Converts MAP (512x512 array) to uint8's, and saves as FILENAME
%(where FILENAME should be something like "image.bns")
%
%NOTE: the map is rotated 90 degrees anticlockwise before saving
%so that THE IMAGE ON THE _SAMPLE_ (note NOT the monitor)
%IS THE SAME AS THE IMAGE OF 'MAP' WHEN SHOWN BY IMAGESC(MAP)
%Image on the monitor is flipped up/down of the actual image
%on the sample (for the optical setup as of Feb 2002).
%
%See also BNS2MAP, IMAGE2BNS.

function map2bns(tmpmap,filename)


%map2bns.m
%By Steve D. Sharples.

%This program is free software; you can redistribute it and/or
%modify it under the terms of the GNU General Public License
%as published by the Free Software Foundation; either version 2
%of the License, or (at your option) any later version.

%This program is distributed in the hope that it will be useful,
%but WITHOUT ANY WARRANTY; without even the implied warranty of
%MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%GNU General Public License for more details.

%You should have received a copy of the GNU General Public License
%along with this program; if not, write to the Free Software
%Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

%The author's email address is steve.sharples@nottingham.ac.uk

tmp2map=rot90(tmpmap,3);
map=uint8(tmp2map);
fo=fopen(filename,'w');fwrite(fo,map,'uint8');fclose(fo);

